
<?php
// Exit if accessed directly
if ( !defined( 'ABSPATH' ) ) exit;

// BEGIN ENQUEUE PARENT ACTION
// AUTO GENERATED - Do not modify or remove comment markers above or below:

// END ENQUEUE PARENT ACTION

/* Actualizar importes de carrito al cambiar cantidades */
add_action( 'wp_footer', 'ayudawp_actualizar_importe_carrito_cambio_cantidad' );
function ayudawp_actualizar_importe_carrito_cambio_cantidad() {
if (is_cart()) :
?>
<script>
jQuery('div.woocommerce').on('change', '.qty', function(){
jQuery("[name='update_cart']").prop("disabled", false);
jQuery("[name='update_cart']").trigger("click"); 
});
</script>
<?php
endif;
}


/** Personalización página del producto **/
function woocommerce_output_product_data_tabs() {
   $product_tabs = apply_filters( 'woocommerce_product_tabs', array() );
   if ( empty( $product_tabs ) ) return;
   echo '<div class="woocommerce-tabs wc-tabs-wrapper">';
   foreach ( $product_tabs as $key => $product_tab ) {
      ?>
         <div id="tab-<?php echo esc_attr( $key ); ?>">
            <?php
            if ( isset( $product_tab['callback'] ) ) {
               call_user_func( $product_tab['callback'], $key, $product_tab );
            }
            ?>
         </div>
      <?php         
   }
   echo '</div>';
}

/** Eliminar la pestaña de información adicional de todos los productos **/
 
add_filter( 'woocommerce_product_tabs', 'remove_info_tab', 98);
function remove_info_tab($tabs) {
 
 unset($tabs['additional_information']);
 
 return $tabs;
}


/** Logos personalizados pago checkout **/
add_filter ('woocommerce_gateway_icon', function ($contenido, $id) {

     if ('ppcp-gateway' == $id)
         return '<img src="/wp-content/plugins/woocommerce/includes/gateways/paypal/assets/images/paypal.png" alt="PayPal" />';

     return $contenido;
}, 10, 2);

add_filter ('woocommerce_gateway_icon', function ($contenido, $id) {

     if ('bacs' == $id)
         return '<img src="https://waterluxe-osmosis.es/wp-content/uploads/2018/06/logo-cajamar.jpg" alt="Transferencia" width="50" />';

     return $contenido;
}, 10, 2);

add_filter ('woocommerce_gateway_icon', function ($contenido, $id) {

     if ('stripe' == $id)
         return '<img src="https://waterluxe-osmosis.es/wp-content/uploads/2022/04/5b3aa3f84413fVisa-MasterCard-in-Iran-.jpg" alt="Stripe" width="60" />';

     return $contenido;
}, 10, 2);


/** Quita el contador de productos en las categorías **/
add_filter( 'woocommerce_subcategory_count_html', 'woo_remove_category_products_count' );

function woo_remove_category_products_count() {
  return;
}


//Ocultar los dos ceros en precios
 add_filter( 'woocommerce_price_trim_zeros', '__return_true' );
 

/** Almacenar términos y condiciones en la base de datos **/
add_action('woocommerce_checkout_update_order_meta', 'woo_save_terms_and_conditions_status');
function woo_save_terms_and_conditions_status( $order_id ) {
    if ($_POST['terms']) update_post_meta( $order_id, '_terms', esc_attr($_POST['terms']));
}
add_action( 'woocommerce_admin_order_data_after_billing_address', 'woo_display_terms_and_conditions_status', 10, 1 );

function woo_display_terms_and_conditions_status($order){
    $terms = get_post_meta( $order->id, '_terms', true );
    $terms_status = ( $terms == 'on' ? __('aceptado') : __('aceptado') );
    echo '<p><strong>'.__('Términos y condiciones').':</strong> ' . $terms_status . '</p>';
}


/** Aceptación después del formulario de comentarios **/
add_filter( 'comment_form_field_comment', 'mi_campo_de_privacidad_en_comentarios' );
function mi_campo_de_privacidad_en_comentarios( $comment_field ) {
    return $comment_field.'<label class="pprivacy"><input type="checkbox" name="privacy" value="privacy-key" class="privacyBox" aria-required="true">&nbsp;&nbsp;Acepto la <a target="blank" href="https://waterluxe-osmosis.es/politica-de-privacidad/">política de privacidad</a></label>';
}
//validación por javascript
add_action('wp_footer','validate_privacy_comment_javascript');
function validate_privacy_comment_javascript(){
 if (! is_admin() && is_single() && comments_open() ){
        wp_enqueue_script('jquery');
        ?>
        <script type="text/javascript">
        jQuery(document).ready(function($){
            $("#submit").click(function(e)){
                if (!$('.privacyBox').prop('checked')){
                    e.preventDefault();
                    alert('Debes aceptar nuestra política de privacidad <p><a href="javascript:history.back()">' . __('&laquo; Volver') . '</a></p>');
                    return false;
                }
            }
        });
        </script>
        <?php
}
}

//sin validación js
add_filter( 'preprocess_comment', 'verify_comment_privacy' );
function verify_comment_privacy( $commentdata ) {
if ( ! isset( $_POST['privacy'] ) && ! is_admin() )
wp_die( __( 'Error: Debes confirmar que estás de acuerdo con nuestra política de privacidad<p><a href="javascript:history.back()">' . __('&laquo; Volver') . '</a></p>' ) );

    return $commentdata;
}

//guarda el campo como comment meta
add_action( 'comment_post', 'save_comment_privacy' );
function save_comment_privacy( $comment_id ) {
    add_comment_meta( $comment_id, 'privacy', $_POST[ 'privacy' ] );
}
/** Primera capa privacidad en comentarios **/
$acceptance = '<p class="comment-reply-title comentarios"></p>
<p class="comment-subscription-form"><ul><li>Responsable: Agua de Lujo S.L.</li>
<li>Fin del tratamiento: Controlar el spam, gestión de comentarios</li>
<li>Legitimación: Tu consentimiento</li>
<li>Comunicación de los datos: No se comunicarán los datos a terceros salvo por  obligación legal.</li>
<li>Derechos: Acceso, rectificación, portabilidad, olvido.</li>
<li>Contacto: <a href="mailto:info@waterluxe.es" title="Contacta">info@waterluxe.es</a>.</li>
<li>Información adicional: Más información en <a href="https://waterluxe-osmosis.es/politica-de-privacidad/" title="Política de Privacidad">nuestra política de privacidad</a>.</li></ul></p>';
function ft_acceptance_comments( $form ) {
	global $acceptance;
	return $form . $acceptance;
}
	add_action( 'comment_form_field_comment', 'ft_acceptance_comments' );
	
	

//Cambia Inicio por Tienda
add_filter( 'woocommerce_breadcrumb_defaults', 'jk_change_breadcrumb_home_text' );
function jk_change_breadcrumb_home_text( $defaults ) {
    // Cambia el texto inicio de las migas de pan de 'Inicio' a 'Tienda'
	$defaults['home'] = 'Tienda';
	return $defaults;
}


//Botón seguir comprando en el carrito
add_action( 'woocommerce_after_cart_totals', 'function_woocommerce_after_cart_totals' );
function function_woocommerce_after_cart_totals() {
 echo '<div id="woocommerce_after_cart_totals" class="hmu-hook"><p><a class="miboton" href="https://waterluxe-osmosis.es/"> <i class="fas fa-long-arrow-alt-left"></i> Seguir comprando</a></p></div>';
}


//Traduce texto en woocommerce
function my_text_strings( $translated_text, $text, $domain ) {
	switch ( $translated_text ) {
		case 'Número de la casa y nombre de la calle' :
			$translated_text = __( 'Nombre de la calle, avenida, número, piso, esc...', 'woocommerce' );
			break;
		case 'Si ya eres cliente, por favor, rellena tus datos a continuación. Si eres un nuevo cliente, continúa en la sección de facturación.' :
			$translated_text = __( 'Si ya eres cliente inicia sesión. Si no eres cliente, continúa con el proceso de compra.', 'woocommerce' );
			break;
		case 'Nombre de usuario o correo electrónico' :
			$translated_text = __( 'Correo electrónico', 'woocommerce' );
			break;
		case 'Localidad / Ciudad' :
			$translated_text = __( 'Localidad', 'woocommerce' );
			break;
		case 'Upload up to 3 images for your review' :
			$translated_text = __( 'Puedes añadir hasta 3 imágenes a tu comentario', 'woocommerce' );
			break;
		case 'Verified review' :
			$translated_text = __( 'Comentario verificado', 'woocommerce' );
			break;
		case 'verified owner' :
			$translated_text = __( 'Cliente verificado', 'woocommerce' );
			break;
		case 'Detalles de facturación' :
			$translated_text = __( 'Datos de facturación', 'woocommerce' );
			break;
		case 'términos y condiciones' :
			$translated_text = __( 'términos * condiciones * política de privacidad', 'woocommerce' );
			break;
		case 'Las opciones de envío se actualizarán durante el pago.' :
			$translated_text = __( 'Envío insular o fuera de España calcula el envío', 'woocommerce' );
			break;
		case 'ID de pedido' :
			$translated_text = __( 'Número de pedido', 'woocommerce' );
			break;
		case 'Correo electrónico de facturación' :
			$translated_text = __( 'Correo electrónico', 'woocommerce' );
			break;
		case 'País / Región' :
			$translated_text = __( 'País', 'woocommerce' );
			break;
		case 'Q & A' :
			$translated_text = __( 'Preguntas', 'woocommerce' );
			break;
		case 'Añadir una nueva forma de pago' :
			$translated_text = __( 'Añadir una tarjeta de crédito nueva', 'woocommerce' );
			break;
		case 'Si tienes un código de cupón, por favor, aplícalo abajo.' :
			$translated_text = __( 'Si tienes un cupón promocional canjealo ahora. De lo contrario, continúa con la compra.', 'woocommerce' );
			break;
			case 'Add More' :
			$translated_text = __( 'Añadir más', 'woocommerce' );
			break;
		case 'Tus detalles' :
			$translated_text = __( 'Facturación y envío', 'woocommerce' );
			break;
		case 'Tu Pedido' :
			$translated_text = __( 'Finalizar compra', 'woocommerce' );
			break;
		case 'Estimation shipping time:' :
			$translated_text = __( 'Fecha de entrega aproximada de tu pedido:', 'woocommerce' );
			break;
		case 'Type:' :
			$translated_text = __( 'Tipo:', 'woocommerce' );
			break;
		case 'Free Product' :
			$translated_text = __( 'Producto de regalo', 'woocommerce' );
			break;
		case 'Código de cupón' :
			$translated_text = __( 'Introduce aquí el código', 'woocommerce' );
			break;
		case 'NIF/DNI' :
			$translated_text = __( 'CIF/DNI/NIE', 'woocommerce' );
			break;
		case 'Search' :
			$translated_text = __( 'Buscar', 'woocommerce' );
			break;
		case 'Privacy Policy' :
			$translated_text = __( 'política de privacidad', 'woocommerce' );
			break;
		case 'Comprar por categoría' :
			$translated_text = __( 'Categorías principales', 'woocommerce' );
			break;
		case 'Favoritos de los fans' :
			$translated_text = __( 'Productos más valorados', 'woocommerce' );
			break;
		case 'Rebajados' :
			$translated_text = __( 'Productos en oferta', 'woocommerce' );
			break;
		case 'Pro-forma' :
			$translated_text = __( 'Factura', 'woocommerce' );
			break;
			case 'Dirección de correo electrónico' :
		$translated_text = __( 'Correo electrónico', 'woocommerce' );
			break;
			case 'Teléfono' :
		$translated_text = __( 'Teléfono (Necesario para la entrega)', 'woocommerce' );
			break;
			case '¿Enviar a una dirección diferente?' :
		$translated_text = __( 'Activa esta casilla si deseas envíar tu pedido a una dirección diferente a la de facturación.', 'woocommerce' );
			break;
			case 'Addresses' :
		$translated_text = __( 'Direcciones', 'woocommerce' );
			break;
			
			
	}
	return $translated_text;
}
add_filter( 'gettext', 'my_text_strings', 20, 3 );

add_filter('gettext',  'translate_text');
add_filter('ngettext',  'translate_text');
 
function translate_text($translated) {
  $translated = str_ireplace('¿Perdiste tu contraseña? Por favor, introduce tu nombre de usuario o correo electrónico. Recibirás un enlace para crear una contraseña nueva por correo electrónico.',  'Si no recuerdas tu contraseña te enviaremos un enlace por correo electrónico para crear una nueva (si no visualizas nuestro correo electrónico, revisa tu bandeja de spam).',  $translated);
     return $translated;
}


/** Desactiva todos los scripts y estilos de WooCommerce excepto en las páginas de la tienda **/
add_action( 'wp_enqueue_scripts', 'dequeue_woocommerce_styles_scripts', 99 );
function dequeue_woocommerce_styles_scripts() {
if ( function_exists( 'is_woocommerce' ) ) {
if ( ! is_woocommerce() &&! is_cart() &&! is_account_page() &&! is_checkout() ) {
# Styles
wp_dequeue_style( 'woocommerce-general' );
wp_dequeue_style( 'woocommerce-layout' );
wp_dequeue_style( 'woocommerce-smallscreen' );
wp_dequeue_style( 'woocommerce_frontend_styles' );
wp_dequeue_style( 'woocommerce_fancybox_styles' );
wp_dequeue_style( 'woocommerce_chosen_styles' );
wp_dequeue_style( 'woocommerce_prettyPhoto_css' );
# Scripts
wp_dequeue_script( 'selectWoo' );
wp_deregister_script( 'selectWoo' );
wp_dequeue_script( 'wc-add-payment-method' );
wp_dequeue_script( 'wc-lost-password' );
wp_dequeue_script( 'wc-credit-card-form' );
wp_dequeue_script( 'wc_price_slider' );
wp_dequeue_script( 'wc-single-product' );
wp_dequeue_script( 'wc-add-to-cart' );
wp_dequeue_script( 'wc-cart-fragments' );
wp_dequeue_script( 'wc-checkout' );
wp_dequeue_script( 'wc-add-to-cart-variation' );
wp_dequeue_script( 'wc-single-product' );
wp_dequeue_script( 'wc-cart' );
wp_dequeue_script( 'wc-chosen' );
wp_dequeue_script( 'woocommerce' );
//wp_dequeue_script( 'prettyPhoto' );
//wp_dequeue_script( 'prettyPhoto-init' );
wp_dequeue_script( 'jquery-blockui' );
wp_dequeue_script( 'jquery-placeholder' );
wp_dequeue_script( 'fancybox' );
wp_dequeue_script( 'jqueryui' );
wp_dequeue_script( 'wc-wishlist' );
}
}
}


//Elimina el titulo de la homepage
add_action( 'wp', 'bbloomer_storefront_remove_title_from_home_homepage_template' );
 
function bbloomer_storefront_remove_title_from_home_homepage_template() {
   remove_action( 'storefront_homepage', 'storefront_homepage_header', 10 );
}


//Añadir la foto del producto en el email de pedido
function dpw_add_images_woocommerce_emails( $output, $order ) {
 
 static $run = 0;
 
 if ( $run ) {
 return $output;
 }
  
	$args = array(
    'show_sku'      => true,
    'show_image'    => true,
    'image_size'    => array( 100, 100 ),
);
 $run++;
 
 return wc_get_email_order_items( $order, $args );
}
add_filter( 'woocommerce_email_order_items_table', 'dpw_add_images_woocommerce_emails', 10, 2 );


//Añade contenido al final de la Homepage
add_action( 'storefront_homepage_after_best_selling_products', 'function_storefront_homepage_after_best_selling_products' );
function function_storefront_homepage_after_best_selling_products() {
  
  echo '<h2><p style="color:black ;">Comentarios más recientes</p></h2>' . do_shortcode('[cusrev_reviews_slider]');
  
  
  echo '<p><img class="size-full wp-image-35559 aligncenter" src="https://waterluxe-osmosis.es/wp-content/uploads/2021/03/waterluxe-te-devuelve-dinero.png" alt="waterluxe-te-devuelve-dinero" width="2446" height="562" /></p>';
  
  echo '<p><img class="aligncenter size-full wp-image-31227" src="https://waterluxe-osmosis.es/wp-content/uploads/2020/06/waterluxe-compra-segura-100.png" alt="" width="2446" height="562" /></p>';
  
  echo '<br><p><strong>Waterluxe es tu tienda online especializada en el tratamiento del agua</strong>.</p>
<p>Nuestra web est&aacute; especialmente dise&ntilde;ada para que tu experiencia de compra sea f&aacute;cil y sencilla. Nuestra m&aacute;xima prioridad es convertir esta tienda online en un comercio electr&oacute;nico totalmente adaptado a todo tipo de usuarios, tanto los que empiezan a realizar sus primeras compras por internet, como los m&aacute;s experimentados.</p>
<p>Dispones de un departamento t&eacute;cnico para cualquier consulta que guarde relaci&oacute;n con nuestra actividad. Si no encuentras lo que buscas o necesitas un producto a medida, no dudes en hacernos la consulta, estaremos encantados de ayudarte.</p>
<p>Trabajamos con las mejores marcas del mercado, solo distribuimos productos de primera calidad.</p>
<p>Los fabricantes m&aacute;s relevantes del mercado conf&iacute;an en Waterluxe para distribuir sus productos, en los que se incluyen: <strong>kinetico</strong>, <strong>Green Filter</strong>, <strong>Hidrowater</strong>, <strong>Ionfilter</strong>, <strong>Ceasa</strong>, <strong>Osmofilter</strong>, <strong>Insol</strong>, <strong>Astralpool</strong>, <strong>Waterfilter</strong>, <strong>Filmtec</strong>, <strong>Prinze</strong>, <strong>ATH</strong>,&nbsp;<strong>Clever</strong>,&nbsp;<strong>Vontron</strong> y muchos m&aacute;s.</p>';
  
}


//Añade una columna en el listado de usuarios con el total de gasto acumulado en la tienda.
add_filter( 'manage_users_columns', 'add_customer_spent_column' );
function add_customer_spent_column($columns) {

    $columns[ 'customer_spent' ] = __( 'Money Spent', 'woocommerce' );
    return $columns;
}
 
add_action( 'manage_users_custom_column',  'show_customer_spent_column_content', 10, 3 );
function show_customer_spent_column_content( $value, $column_name, $user_id ) {
    
    $customer_spent = wc_price( wc_get_customer_total_spent( $user_id ) );
    if ( 'customer_spent' == $column_name ){

        $value = $customer_spent;
    }

    return $value;
}

function user_sortable_columns( $columns ) {
    $columns['customer_spent'] = 'customer_spent';
    return $columns;
}
add_filter( 'manage_users_sortable_columns', 'user_sortable_columns' );

function money_spent_column_orderby( $vars ) {

    if ( isset( $vars->query_vars['orderby'] ) && 'customer_spent' == $vars->query_vars['orderby'] ) {
        
        global $wpdb;

        $vars->query_from .= " LEFT OUTER JOIN $wpdb->usermeta AS alias ON ($wpdb->users.ID = alias.user_id) ";
        $vars->query_where .= " AND alias.meta_key = '_money_spent' ";
        $vars->query_orderby = " ORDER BY alias.meta_value ".($vars->query_vars[ 'order' ] == "ASC" ? "asc " : "desc ");
    }

    return $vars;
}
add_filter( 'pre_user_query', 'money_spent_column_orderby', 10, 1 );


//Esto pone contenido en el top bar.
 
function storefront_add_topbar() {
    ?>
    <div id="topbar">
        <div class="col-full">
            <p><p style="text-align: center;"><i class="fas fa-shipping-fast"></i> Gratis a partir de 59<small>€</small> en miles de productos</p>
        </div>
    </div>
    <?php
}
add_action( 'storefront_before_header', 'storefront_add_topbar' );


//Añadir agencias de transporte
add_filter( 'wc_shipment_tracking_get_providers' , 'wc_shipment_tracking_add_custom_provider' );
function wc_shipment_tracking_add_custom_provider( $providers ) {
	
	$providers['España'] ['Ctt Express'] = 'https://www.cttexpress.com/localizador-de-envios/?objects=%1$s';
	$providers['España'] ['Schenker'] = 'https://eschenker.dbschenker.com/nges-portal/public/es-ES_ES/#!/tracking/customer-search?refType=cu&refNumber=%1$s';
	$providers['España'] ['UPS'] = 'https://www.ups.com/track?tracknum=%1$s';
	$providers['España'] ['ViaXpress'] = 'http://viaxpress.es/Home.aspx';
	$providers['España'] ['Transaher'] = 'https://clientes.transaher.es/mclient/htracking.aspx?-2,%1$s';
	$providers['España'] ['Genei'] = 'https://www.genei.es';
	$providers['España'] ['Correos'] = 'http://www.correos.es/ss/Satellite/site/aplicacion-4000003383089-herramientas_y_apps/detalle_app-sidioma=es_ES?numero=%1$s';
	$providers['España'] ['Correos Premium'] = 'http://www.correos.es/ss/Satellite/site/aplicacion-4000003383089-herramientas_y_apps/detalle_app-sidioma=es_ES?numero=%1$s';
    $providers['España'] ['Zeleris'] = 'https://www.zeleris.com/seguimiento_envio.aspx?id_seguimiento=%1$s';
    $providers['España'] ['Correos Express'] = 'https://s.correosexpress.com/search?shippingNumber=%1$s';
    $providers['España'] ['Seur'] = 'http://www.seur.com/seguimiento-online.do';
    $providers['España'] ['DHL'] = 'https://clientesparcel.dhl.es/LiveTracking/';
    $providers['España'] ['TSB'] = 'https://www.tsbconnect.net/tracking/search?number=%1$s';
    $providers['España'] ['GLS'] = 'https://www.gls-spain.es/es/ayuda/seguimiento-envio/?international=1&match=%1$s';
    $providers['España'] ['Redur'] = 'http://redlink.redur.es/RedLink/jsp/jsp_esp/listadoExpedicionesG.jsp?cliente=BAEZAMAL&valorreferencia=%1$s';
    $providers['España'] ['TNT'] = 'https://www.tnt.com/express/es_es/site/herramientas-envio/seguimiento.html?searchType=con&cons=%1$s';
	// etc...
	
	return $providers;
	
}


//Elimina agencia de transportes
add_filter( 'wc_shipment_tracking_get_providers', 'custom_shipment_tracking' );

function custom_shipment_tracking( $providers ) {

    unset($providers['Australia']);
    unset($providers['Austria']);
    unset($providers['Brazil']);
    unset($providers['Belgium']);
    unset($providers['Canada']);
    unset($providers['Czech Republic']);
    unset($providers['Finland']);
    unset($providers['France']);
    unset($providers['Germany']);
    unset($providers['Ireland']);
    unset($providers['Italy']);
    unset($providers['India']);
    unset($providers['Netherlands']);
    unset($providers['Romania']);
    unset($providers['South African']);
    unset($providers['Sweden']);
    unset($providers['New Zealand']);
    unset($providers['United Kingdom']);
    unset($providers['United States']['Fedex']);
    unset($providers['United States']['Fedex Sameday']);
    unset($providers['United States']['UPS']);
    unset($providers['United States']['USPS']);
    unset($providers['United States']['OnTrac']);
    unset($providers['United States']['DHL US']);

    return $providers;
}


//Cambia la agencia de envío predeterminada
add_filter( 'woocommerce_shipment_tracking_default_provider', 'custom_woocommerce_shipment_tracking_default_provider' );

function custom_woocommerce_shipment_tracking_default_provider( $provider ) {
	$provider = 'Ctt Express'; // Reemplace esto con el nombre del proveedor.

	return $provider;
}


//Límite de ventas cruzadas carrito woocommerce
add_filter('woocommerce_cross_sells_total', 'cartCrossSellTotal');
function cartCrossSellTotal($total) {
	$total = '2';
	return $total;
}


//Personaliza el Top Bar CSS
add_action( 'wp_head', function () { ?>
	<style>

		/* write your CSS code here */
#topbar {
    background-color: #000;
    height: 35px;
    line-height: 35px;
}

#topbar p {
    color: #fff;
    width: 100%;
    text-align: center;
    margin: 0;
    font-size:16px;
    font-weight:600;
}

/*Elimina top bar en ciertas páginas*/
.page-id-1189 #topbar {
    display: none;
}
/*Elimina top bar del blog*/
.single-post #topbar{
	display: none;
}		   
		   
	</style>
<?php } );


/*Envío gratuito*/
add_action( 'woocommerce_product_options_general_product_data', 'bbloomer_add_badge_checkbox_to_products' );        
  
function bbloomer_add_badge_checkbox_to_products() {           
woocommerce_wp_checkbox( array( 
'id' => 'custom_badge', 
'class' => '', 
'label' => 'Envío gratuito'
) 
);      
}
  
// -----------------------------------------
// 2. Save checkbox via custom field
  
add_action( 'save_post', 'bbloomer_save_badge_checkbox_to_post_meta' );
  
function bbloomer_save_badge_checkbox_to_post_meta( $product_id ) {
    if ( defined( 'DOING_AUTOSAVE' ) && DOING_AUTOSAVE )
        return;
    if ( isset( $_POST['custom_badge'] ) ) {
            update_post_meta( $product_id, 'custom_badge', $_POST['custom_badge'] );
    } else delete_post_meta( $product_id, 'custom_badge' );
}
// 3. Display badge @ single product page if checkbox checked
  
add_action( 'woocommerce_before_add_to_cart_button', 'bbloomer_display_badge_if_checkbox', 6 );
  
function bbloomer_display_badge_if_checkbox() {
    global $product;     
    if ( get_post_meta( $product->get_id(), 'custom_badge', true ) ) {
        echo '
<div class="note"><p style="color:#008000; font-size:16px; padding:1px; text-align:center; background:#d4edda; font-weight:600; margin-right:80px; margin-bottom:30px;"><i class="fas fa-check-circle"></i> Envío gratuito en España penínsular</div>
 
';
    }
}


/*Sobrecargo PayPal | cambialo por ppcp-gateway cuando se resuelva el problema*/

add_action( 'woocommerce_cart_calculate_fees', 'bbloomer_add_checkout_fee_for_gateway' );
 
function bbloomer_add_checkout_fee_for_gateway() {
 
  global $woocommerce;
 
  $chosen_gateway = $woocommerce->session->chosen_payment_method;
   
  if ( $chosen_gateway == 'paypal' ) {
   
   
    $percentage = 0.029;
    $costeFijo = 0.35;
    $surcharge = ( $woocommerce->cart->cart_contents_total + $woocommerce->cart->shipping_total ) * $percentage + $costeFijo ;  
    $woocommerce->cart->add_fee( 'PayPal +', $surcharge, true, '');
 
  }
 
}
// Part 2: reload checkout on payment gateway change
 
add_action( 'woocommerce_review_order_before_payment', 'bbloomer_refresh_checkout_on_payment_methods_change' );
 
function bbloomer_refresh_checkout_on_payment_methods_change(){
    ?>
    <script type="text/javascript">
        (function($){
            $( 'form.checkout' ).on( 'change', 'input[name^="payment_method"]', function() {
                $('body').trigger('update_checkout');
            });
        })(jQuery);
    </script>
    <?php
}


//Eliminar envío gratis si hay ciertos productos en el carrito.
add_filter( 'woocommerce_package_rates', 'qreuz_force_shipping_when_class_in_cart', 10, 2);

function qreuz_force_shipping_when_class_in_cart( $rates, $package ) {
	
	$shipping_class_slug = 'productos-especiales'; // slug del método de envío especial
	
	$shipping_method_id = 'free_shipping'; // id del método de envío gratis
	
	$shipping_class_in_cart = false;
	
	foreach( WC()->cart->get_cart() as $cart_item ) {
        if( $cart_item['data']->get_shipping_class() == $shipping_class_slug ) {
		  $shipping_class_in_cart = true;
		  break;
		 } 
	}

	if ($shipping_class_in_cart) {
		
		$shipping_methods_disable = array();

		foreach ( $rates as $rate_id => $rate ) {
			if ( $shipping_method_id !== $rate->method_id ) {
				$shipping_methods_disable[ $rate_id ] = $rate;
			}
		}
	}
	
	return ! empty( $shipping_methods_disable ) ? $shipping_methods_disable : $rates;
} 


//Cuanto falta para envío gratis
add_action( 'woocommerce_after_cart', 'bbloomer_free_shipping_cart_notice' );
  
function bbloomer_free_shipping_cart_notice() {
  
  $shipping_class_slug = 'productos-especiales'; // slug del método de envío especial
	
	$shipping_class_in_cart = false;
	
	foreach( WC()->cart->get_cart() as $cart_item ) {
        if( $cart_item['data']->get_shipping_class() == $shipping_class_slug ) {
		  $shipping_class_in_cart = true;
		  break;
		 } 
	}
  
$min_amount = 59; //change this to your free shipping threshold
   
$current = WC()->cart->subtotal;
  
if ( !$shipping_class_in_cart && $current < $min_amount ) {
   $added_text = esc_html__('Solo faltan ', 'woocommerce' ) . wc_price( $min_amount - $current ) . esc_html__(' para envío gratis en península ', 'woocommerce' );
   $return_to = apply_filters( 'woocommerce_continue_shopping_redirect', wc_get_raw_referer() ? wp_validate_redirect( wc_get_raw_referer(), false ) : wc_get_page_permalink( 'shop' ) );
   $notice = sprintf( '<a href="%s" class="">%s</a> %s', esc_url( $return_to ), esc_html__( '', 'woocommerce' ), $added_text );
   wc_print_notice( $notice, 'notice' );
}
  
}

/*Elimina mensaje cupón al inicio del checkout
 
remove_action( 'woocommerce_before_checkout_form', 'woocommerce_checkout_coupon_form', 10 );
 
/*Mueve campo cupón al final del checkout
 
add_action( 'woocommerce_review_order_after_submit', 'bbloomer_checkout_coupon_below_payment_button' );
 
function bbloomer_checkout_coupon_below_payment_button() {
   echo '<hr>';
   woocommerce_checkout_coupon_form();
}
*/

/*mueve cupón hacia bajo en carrito
add_action( 'woocommerce_proceed_to_checkout', 'display_coupon_form_below_proceed_checkout', 25 );
 
function display_coupon_form_below_proceed_checkout() {
   ?> 
      <form class="woocommerce-coupon-form" action="<?php echo esc_url( wc_get_cart_url() ); ?>" method="post">
         <?php if ( wc_coupons_enabled() ) { ?>
            <div class="coupon under-proceed">
               <input type="text" name="coupon_code" class="input-text" id="coupon_code" value="" placeholder="<?php esc_attr_e( 'Coupon code', 'woocommerce' ); ?>" style="width: 100%" /> 
               <button type="submit" class="button" name="apply_coupon" value="<?php esc_attr_e( 'Apply coupon', 'woocommerce' ); ?>" style="width: 100%"><?php esc_attr_e( 'Apply coupon', 'woocommerce' ); ?></button>
            </div>
         <?php } ?>
      </form>
   <?php
}
*/

/*Núnmero de productos por fila y columnas*/
add_filter( 'woocommerce_output_related_products_args', 'bbloomer_change_number_related_products', 9999 ); 
function bbloomer_change_number_related_products( $args ) {
 $args['posts_per_page'] = 4; // # of related products
 $args['columns'] = 4; // # of columns per row
 return $args;
}
/* Mostrar productos relacionados en WooCommerce solo por categorias */
add_filter ('woocommerce_product_related_posts_relate_by_tag', function () {
    return false;
});


//Elimina el filtro Capital P Dangit
remove_filter( 'the_title', 'capital_P_dangit', 11 );
remove_filter( 'the_content', 'capital_P_dangit', 11 );
remove_filter( 'comment_text', 'capital_P_dangit', 31 );

// Removes some links from the header
function remove_headlinks() {
    remove_action( 'wp_head', 'wp_generator' );
    remove_action( 'wp_head', 'rsd_link' );
    remove_action( 'wp_head', 'wlwmanifest_link' );
    remove_action( 'wp_head', 'start_post_rel_link' );
    remove_action( 'wp_head', 'index_rel_link' );
    remove_action( 'wp_head', 'wp_shortlink_wp_head' );
    remove_action( 'wp_head', 'adjacent_posts_rel_link' );
    remove_action( 'wp_head', 'adjacent_posts_rel_link_wp_head', 10, 0 );
    remove_action( 'wp_head', 'parent_post_rel_link' );
    remove_action( 'wp_head', 'feed_links', 2 );
    remove_action( 'wp_head', 'feed_links_extra', 3 );
    remove_action( 'wp_head', 'print_emoji_detection_script', 7 );
    remove_action( 'wp_print_styles', 'print_emoji_styles' );
    remove_filter( 'wp_mail', 'wp_staticize_emoji_for_email' );
    remove_filter( 'the_content_feed', 'wp_staticize_emoji' );
    remove_filter( 'comment_text_rss', 'wp_staticize_emoji' );
}
add_action( 'init', 'remove_headlinks' );


//Quitar menu marketing de WooCommerce en admin
add_filter( 'woocommerce_admin_features', 'disable_features' );
function disable_features( $features ) {
$marketing = array_search('marketing', $features);
unset( $features[$marketing] );
$analytics = array_search('analytics', $features);
unset( $features[$analytics] );
return $features;
}


//Desactiva la vista previa de las miniaturas de PDF
function wpb_disable_pdf_previews() { 
$fallbacksizes = array(); 
return $fallbacksizes; 
} 
add_filter('fallback_intermediate_image_sizes', 'wpb_disable_pdf_previews');


//Evita que el plugin RGPD funciones con Ajax
add_action( 'gdpr_cc_prevent_ajax_script_inject', '__return_true' );


//Superpone al banner de la GPRD
add_action('moove_gdpr_inline_styles','gdpr_cookie_css_extension_zindex',10,3);
function gdpr_cookie_css_extension_zindex( $styles, $primary, $secondary ) {
  $styles .= '#moove_gdpr_cookie_info_bar { z-index: 99999999; }';
  $styles .= '.lity { z-index: 999999999; }';
  return $styles;
}


/* Optimizar la carga de lity.css del plugin de GDPR */
add_action( 'gdpr_enqueue_lity_nojs', '__return_false' );
add_action( 'gdpr_cc_prevent_ajax_script_inject', '__return_true' );


//Desactivar el aviso de WooCommerce.com
add_filter( 'woocommerce_helper_suppress_admin_notices', '__return_true' );


/* Desactivar menú extensiones de WooCommerce */
add_action( 'admin_menu', 'wcbloat_remove_admin_addon_submenu', 999 );
function wcbloat_remove_admin_addon_submenu() {
remove_submenu_page( 'woocommerce', 'wc-addons');
}
add_filter( 'woocommerce_allow_marketplace_suggestions', '__return_false', 999 ); //Sugerencias extensiones
add_filter( 'woocommerce_helper_suppress_admin_notices', '__return_true' ); //Conectarse a woocommerce.com


// Desactivar campos calculadora de envios
 
// 2 Disable City
add_filter( 'woocommerce_shipping_calculator_enable_city', '__return_false' );
 
// 3 Disable Postcode
add_filter( 'woocommerce_shipping_calculator_enable_postcode', '__return_false' );


/* Crear cuenta activo por defecto */
add_filter('woocommerce_create_account_default_checked' , function ($checked){
    return true;
});


/* Vaciar carrito*/
add_action( 'woocommerce_after_cart_table', 'custom_woocommerce_empty_cart_button' );
function custom_woocommerce_empty_cart_button() {
	echo '<a href="' . esc_url( add_query_arg( 'empty_cart', 'yes' ) ) . '" class="button wcss-btn" title="' . esc_attr( 'Vaciar carrito', 'woocommerce' ) . '">' . esc_html( 'Vaciar carrito', 'woocommerce' ) . '</a>';
}

add_action( 'wp_loaded', 'custom_woocommerce_empty_cart_action', 20 );
function custom_woocommerce_empty_cart_action() {
	if ( isset( $_GET['empty_cart'] ) && 'yes' === esc_html( $_GET['empty_cart'] ) ) {
		WC()->cart->empty_cart();

		$referer  = wp_get_referer() ? esc_url( remove_query_arg( 'empty_cart' ) ) : wc_get_cart_url();
		wp_safe_redirect( $referer );
	}
}


//Add Privacy Policy Checkbox @ WooCommerce My Account Registration Form
 
add_action( 'woocommerce_register_form', 'bbloomer_add_registration_privacy_policy', 11 );
   
function bbloomer_add_registration_privacy_policy() {
 
woocommerce_form_field( 'privacy_policy_reg', array(
   'type'          => 'checkbox',
   'class'         => array('form-row privacy'),
   'label_class'   => array('woocommerce-form__label woocommerce-form__label-for-checkbox checkbox'),
   'input_class'   => array('woocommerce-form__input woocommerce-form__input-checkbox input-checkbox'),
   'required'      => true,
   'label'         => 'He leído y acepto la <a href="https://waterluxe-osmosis.es/politica-de-privacidad/">politica de privacidad</a>',
));
  
}
  
// Show error if user does not tick
   
add_filter( 'woocommerce_registration_errors', 'bbloomer_validate_privacy_registration', 10, 3 );
  
function bbloomer_validate_privacy_registration( $errors, $username, $email ) {
if ( ! is_checkout() ) {
    if ( ! (int) isset( $_POST['privacy_policy_reg'] ) ) {
        $errors->add( 'privacy_policy_reg_error', __( 'Debes aceptar la politica de privacidad de nuestra tienda', 'woocommerce' ) );
    }
}
return $errors;
}


/** Añade campo información adicional en ajustes de presentación del producto **/
if ( in_array( 'woocommerce/woocommerce.php', get_option( 'active_plugins' ) ) && ( version_compare( WC()->version, '3.0.0', '>=' ) ) ){

	add_filter( 'woocommerce_get_settings_products', 'aditional_product_info_block', 10, 2 );
	function aditional_product_info_block( $settings, $current_section ){

		$settings[] = array(
			'title' => __( 'Información adicional del producto', 'woocommerce' ),
			'type'  => 'title',
			'desc'  => '',
			'id'  => 'adition_product_info_options' 
			);

		$settings[] = array(
			'title'    => __( '¿Donde quieres que se muestre?', 'woocommerce' ),
			'id'       => 'woocommerce_aditional_product_info_layout',
			'class'    => 'wc-enhanced-select',
			'css'      => 'min-width:300px;',
			'default'  => 'menu_order',
			'type'     => 'select',
			'options'  => apply_filters( 'woocommerce_aditional_product_info_layout_options', array(
				'top' => __( 'Encima del botón de compra', 'woocommerce' ),
				'bottom' => __( 'Debajo del botón de compra', 'woocommerce' ),
				) )
			);

		$settings[] = array(
			'type'  => 'my_visual_editor',
			'id'  => 'woocommerce_aditional_product_info_message' 
			);

		$settings[] = array(
			'type'  => 'sectionend',
			'id'  => 'adition_product_info_options'
			);

		return $settings;
	}
	
	add_action( 'woocommerce_admin_field_my_visual_editor', 'generate_my_visual_editor_html' );
	function generate_my_visual_editor_html(){

		$aditional_product_info_message = get_option( 'woocommerce_aditional_product_info_message' );
		?>
		<div><?php wp_editor( !empty( $aditional_product_info_message )? $aditional_product_info_message : '', 'woocommerce_aditional_product_info_message' ); ?></div>
		<?php
	}
	add_filter( 'woocommerce_admin_settings_sanitize_option_woocommerce_aditional_product_info_message', 'sanitize_aditional_product_info', 10, 3 );
	function sanitize_aditional_product_info( $value, $option, $raw_value ){
	  	return  wp_kses_post( $raw_value );
	}
	add_action( 'woocommerce_single_product_summary', 'display_aditional_info_message_in_product_page', get_option( 'woocommerce_aditional_product_info_layout' ) == 'top'? 25 : 35 );
	function display_aditional_info_message_in_product_page(){
		$adition_product_info_message = get_option( 'woocommerce_aditional_product_info_message' );
		?>
		<div style="margin-top: 0px;margin-bottom: 0px;padding-bottom: 0px;"><?php echo do_shortcode( !empty( $adition_product_info_message )? wpautop( $adition_product_info_message ) : '' ); ?></div>
		<?php 
	}
}


// Añadir etiqueta personalizada producto
if ( in_array( 'woocommerce/woocommerce.php', get_option( 'active_plugins' ) ) ){

	add_action( 'woocommerce_before_single_product_summary', 'display_my_custom_label' );
	add_action( 'woocommerce_before_shop_loop_item_title', 'display_my_custom_label' );
	function display_my_custom_label(){
		global $post;
	
		$custom_label = null !== get_post_meta( $post->ID, '_custom_label', true )? get_post_meta( $post->ID, '_custom_label', true ) : '';
		$custom_label_color = !empty( get_post_meta( $post->ID, '_custom_label_color', true ) )? sanitize_hex_color( get_post_meta( $post->ID, '_custom_label_color', true ) ) : '';
		$label_class = get_post_meta( $post->ID, '_custom_label_class', true );
	
		if ( !empty( $custom_label ) ) {
			
			if ( !empty( $custom_label_color ) ) {
				
				echo '<span class="'. $label_class .'" style="background-color: '. $custom_label_color .' !important;">' . $custom_label . '</span>';
			}else{

				echo '<span class="'. $label_class .'">' . $custom_label . '</span>';
			}
		}
	}
	
	// Añade un nuevo campo para el texto de la etiqueta en la ficha de producto
	add_action( 'woocommerce_product_options_general_product_data', 'add_custom_label_settings_field' );
	function add_custom_label_settings_field( ){
		global $post;
	
		wp_nonce_field( plugin_basename(__FILE__), 'woocommerce_custom_label_nonce' );
		echo '<div class="options_group show_if_simple show_if_variable">';
		woocommerce_wp_text_input( 
			array( 
				'id'            => '_custom_label', 
				'label'         => __( 'Texto de la etiqueta', 'woocommerce' ), 
				'description'	=> __( 'Muestra una etiqueta en la foto principal de producto con el texto que desees.', 'woocommerce' ),
				'value'         => get_post_meta( $post->ID, '_custom_label', true )? get_post_meta( $post->ID, '_custom_label', true ) : '',
				'placeholder'	=> 'Ej: ¡Oferta 2x1!',
				)
		);

		woocommerce_wp_text_input( 
			array( 
				'id'            => '_custom_label_color', 
				'label'         => __( 'Color de fondo', 'woocommerce' ), 
				'description'	=> __( 'Este será el color de fondo de la etiqueta.', 'woocommerce' ),
				'value'         => !empty( get_post_meta( $post->ID, '_custom_label_color', true ) )? get_post_meta( $post->ID, '_custom_label_color', true ) : '',
				)
		);
	
		woocommerce_wp_text_input( 
			array( 
				'id'            => '_custom_label_class', 
				'label'         => __( 'Clase de la etiqueta', 'woocommerce' ), 
				'description'	=> __( 'Aplica una clase de estilo personalizada para el diseño de la etiqueta.', 'woocommerce' ),
				'value'         => 'onsale' !== get_post_meta( $post->ID, '_custom_label_class', true )? get_post_meta( $post->ID, '_custom_label_class', true ) : '',
				)
		);
	
		echo '</div>';
	}
	
	// Guarda el valor del nuevo campo
	add_action( 'save_post', 'save_custom_label_settings_field', 99, 2 );
	function save_custom_label_settings_field( $post_id, $post ){
	
		/* --- security verification --- */
		if ( 'product' !== $post->post_type ) {
		    		
		    	return $post_id;
		}
		
		if( !wp_verify_nonce( $_POST['woocommerce_custom_label_nonce'], plugin_basename(__FILE__) ) ) {
			return $post_id;
	    	}
	
	    	if( defined('DOING_AUTOSAVE') && DOING_AUTOSAVE ) {
	    		return $post_id;
	    	}
	
	    	if( 'product' == $_POST['post_type'] ) {
	    		
	    		if( !current_user_can('edit_page', $post_id) ) {
	    			return $post_id;
	      		}
		} else {
		
			if( !current_user_can( 'edit_page', $post_id ) ) {
				return $post_id;
	        	}
	    	}
	    	/* - end security verification - */
		
		if ( isset( $_POST[ '_custom_label' ] ) ) {
			
			$custom_label = !empty( $_POST[ '_custom_label' ] ) ? $_POST[ '_custom_label' ] : '';
			update_post_meta( $post_id, '_custom_label', $custom_label );
		}

		if ( isset( $_POST[ '_custom_label_color' ] ) ) {
			
			$custom_label_color = !empty( $_POST[ '_custom_label_color' ] ) ? $_POST[ '_custom_label_color' ] : '';
			update_post_meta( $post_id, '_custom_label_color', $custom_label_color );
		}
	
		if ( isset( $_POST[ '_custom_label_class' ] ) ) {
			
			$custom_label_class = !empty( $_POST[ '_custom_label_class' ] ) ? $_POST[ '_custom_label_class' ] : 'onsale';
			update_post_meta( $post_id, '_custom_label_class', $custom_label_class );
		}
	}
  
  	add_action( 'admin_enqueue_scripts', 'enqueue_wp_color_picker_script' );
  	function enqueue_wp_color_picker_script(){
		wp_enqueue_script( 'wp-color-picker' );
	}
	
	add_action( 'admin_footer', 'color_field_js', 99 );
	function color_field_js(){
		global $post_type;

		if ( 'product' !== $post_type ) {
			return;
		}

		?>
		<script type="text/javascript">
			jQuery(document).ready(function($){

				$( '#_custom_label_color' ).wpColorPicker();
			});
		</script>
		<?php
	}
}


/* Desactivar widget de escritorio de WooCommerce 
add_action('wp_dashboard_setup', 'wcbloat_disable_woocommerce_status');
function wcbloat_disable_woocommerce_status() {
remove_meta_box('woocommerce_dashboard_status', 'dashboard', 'normal');
}
*/


/* Eliminar sidebar en todas las páginas */
add_action( 'wp', 'dcms_remove_storefront_sidebar' );

function dcms_remove_storefront_sidebar() {
	// Condiciones en donde se tiene que remover el sidebar
	if ( is_page() ){
		remove_action( 'storefront_sidebar', 'storefront_get_sidebar' );

		add_filter( 'body_class', function( $classes ){
			$classes[] = 'page-template-template-fullwidth-php';
			return $classes;
		});
	}
}

/* Añadir imagen del producto en checkout 
add_filter( 'woocommerce_cart_item_name', 'bbloomer_product_image_review_order_checkout', 9999, 3 );
  
function bbloomer_product_image_review_order_checkout( $name, $cart_item, $cart_item_key ) {
    if ( ! is_checkout() ) return $name;
    $product = $cart_item['data'];
    $thumbnail = $product->get_image( array( '50', '50' ), array( 'class' => 'alignleft' ) );
    return $thumbnail . $name;
}
*/


/*Botón pedir de nuevo*/
add_filter( 'woocommerce_my_account_my_orders_actions', 'bbloomer_order_again_action', 9999, 2 );
    
function bbloomer_order_again_action( $actions, $order ) {
    if ( $order->has_status( 'completed' ) ) {
        $actions['order-again'] = array(
            'url' => wp_nonce_url( add_query_arg( 'order_again', $order->get_id(), wc_get_cart_url() ), 'woocommerce-order_again' ),
            'name' => __( 'Comprar de nuevo', 'woocommerce' ),
        );
    }
    return $actions;
}

/*mantenga los datos de facturación, envío y campos personalizados en WooCommerce Checkout*/
add_action( 'woocommerce_checkout_update_order_review', 'bbloomer_save_checkout_values', 9999 );
 
function bbloomer_save_checkout_values( $posted_data ) {
    parse_str( $posted_data, $output );
    WC()->session->set( 'checkout_data', $output );
}
 
add_filter( 'woocommerce_checkout_get_value', 'bbloomer_get_saved_checkout', 9999, 2 );
 
function bbloomer_get_saved_checkout( $value, $index ) {
    $data = WC()->session->get( 'checkout_data' );
    if ( ! $data || empty( $data[$index] ) ) return $value;
    return is_bool( $data[$index] ) ? (int) $data[$index] : $data[$index];
}
 
add_filter( 'woocommerce_ship_to_different_address_checked', 'bbloomer_get_saved_ship_to_different' );
 
function bbloomer_get_saved_ship_to_different( $checked ) {
    $data = WC()->session->get( 'checkout_data' );
    if ( ! $data || empty( $data['ship_to_different_address'] ) ) return $checked;
    return true;
}


/*redirigir a los usuarios a la URL anterior*/
add_action( 'woocommerce_login_form_end', 'bbloomer_actual_referrer' );
 
function bbloomer_actual_referrer() {
   if ( ! wc_get_raw_referer() ) return;
   if ( is_checkout() ) return;
   echo '<input type="hidden" name="redirect" value="' . wp_validate_redirect( wc_get_raw_referer(), wc_get_page_permalink( 'myaccount' ) ) . '" />';
}

//For create account button:
add_action( 'woocommerce_register_form_end', 'bbloomer2_actual_referrer' );
function bbloomer2_actual_referrer() {
   if ( ! wc_get_raw_referer() ) return;
   if ( is_checkout() ) return;
   echo '<input type="hidden" name="redirect" value="' . wp_validate_redirect( wc_get_raw_referer(), wc_get_page_permalink( 'myaccount' ) ) . '" />';
}

/* Distinto aviso para usuario logueado */
add_filter( 'wp_nav_menu_items', 'bbloomer_dynamic_menu_item_label', 9999, 2 ); 
 
function bbloomer_dynamic_menu_item_label( $items, $args ) { 
   if ( ! is_user_logged_in() ) { 
      $items = str_replace( "Mi cuenta", "Acceder", $items ); 
   } 
   return $items; 
}


/* Reemplace el logotipo de WordPress */

add_action( 'login_enqueue_scripts', 'bbloomer_login_logo' );
 
function bbloomer_login_logo() {
   ?>
    <style type="text/css">
        #login h1 a, .login h1 a {
           background-image: url(/wp-content/uploads/2020/04/Logo-para-facturas.png);
           height: 50px;
           width: 250px;
           background-size: contain;
           background-repeat: no-repeat;
           background-color: transparent;
      }
    </style>
   <?php
}
 
add_filter( 'login_headerurl', 'bbloomer_login_logo_link' );
 
function bbloomer_login_logo_link( $url ) {
    return home_url( '/' );
}

/* Unidades vendidas */
add_action( 'woocommerce_single_product_summary', 'bbloomer_product_sold_count', 11 );
  
function bbloomer_product_sold_count() {
   global $product;
   $units_sold = 2 * $product->get_total_sales();
   if ( $units_sold ) echo '<p>' . sprintf( __( 'Unidades vendidas: %s', 'woocommerce' ), $units_sold ) . '</p>';
}


/* Producto variable desde variation*/
add_filter( 'woocommerce_variable_price_html', 'bbloomer_variation_price_format_min', 9999, 2 );
 
function bbloomer_variation_price_format_min( $price, $product ) {
   $prices = $product->get_variation_prices( true );
   $min_price = current( $prices['price'] );
   $max_price = end( $prices['price'] );
   $min_reg_price = current( $prices['regular_price'] );
   $max_reg_price = end( $prices['regular_price'] );
   if ( $min_price !== $max_price || ( $product->is_on_sale() && $min_reg_price === $max_reg_price ) ) {
      $price = 'Desde: ' . wc_price( $min_price ) . $product->get_price_suffix();
   }
   return $price;
}


/*Excluir envíos a ciertas provincias*/
add_filter ('woocommerce_states', 'webempresa_limita_envios');

function webempresa_limita_envios ($provincias) {
   unset ($provincias ['ES'] ['CE']);
   unset ($provincias ['ES'] ['ML']);
   unset ($provincias ['ES'] ['TF']);
   unset ($provincias ['ES'] ['GC']);
   return $provincias;
   }
   

/*
 * Oculta pasarelas de pago si un producto de una categoría está en el carrito.
 *  - Nota: Si se añaden varios productos y solo uno es de la categoría tampoco aparece la pasarela ocultada
 * Uso:
 *    unset available_gateways : Nombre de las pasarelas de pago de WooCommerce que no se verán - paypal, cod, bacs y cheque
 *    category_ids :  Los IDs de categorías para las que ocultar la pasarela de pago. El ID lo tienes haciendo clic en la categoria en Productos -> Categorias, se mostrará el "tag_ID" en la barra de direcciones
 */
add_filter( 'woocommerce_available_payment_gateways', 'ayudawp_quitar_pasarela_por_categoria' );
function ayudawp_quitar_pasarela_por_categoria( $available_gateways ) {
if ( is_admin() ) return $available_gateways;
if ( ! is_checkout() ) return $available_gateways;
$unset = false;
$category_ids = array( 1658,1343 );//Sustituye estos números por los IDs de las categorías en las que se aplica. Si son varias van precedidas por comas, ejem: 1,2,58
foreach ( WC()->cart->get_cart_contents() as $key => $values ) {
$terms = get_the_terms( $values['product_id'], 'product_cat' ); 
foreach ( $terms as $term ) { 
if ( in_array( $term->term_id, $category_ids ) ) {
$unset = true;
break;
}
}
}
if ( $unset == true ) unset( $available_gateways['paypal'] );//Aquí sustituye paypal por la pasarela que quieras desactivar
return $available_gateways;
}


/* Placeholder DNI 
if ( ! function_exists( 'yith_ywpi_change_placeholders_in_checkout' ) ) {
  function yith_ywpi_change_placeholders_in_checkout() {
      $jquery = 'jQuery( document ).ready( function( $ ){          
          $("body.woocommerce-checkout #billing_vat_ssn").attr( "placeholder", "DNI o CIF de empresa sin espacios ni guiones" );
      });';

        wp_add_inline_script( 'woocommerce', $jquery );
  }

    add_action( 'wp_enqueue_scripts', 'yith_ywpi_change_placeholders_in_checkout', 99 );
}
*/

/* Envío email fallido y cancelado a cliente */
add_action('woocommerce_order_status_changed', 'send_custom_email_notifications', 10, 4 );
function send_custom_email_notifications( $order_id, $old_status, $new_status, $order ){
    if ( $new_status == 'cancelled' || $new_status == 'failed' ){
        $wc_emails = WC()->mailer()->get_emails(); // Get all WC_emails objects instances
        $customer_email = $order->get_billing_email(); // The customer email
    }

    if ( $new_status == 'cancelled' ) {
        // change the recipient of this instance
        $wc_emails['WC_Email_Cancelled_Order']->recipient = $customer_email;
        // Sending the email from this instance
        $wc_emails['WC_Email_Cancelled_Order']->trigger( $order_id );
    } 
    elseif ( $new_status == 'failed' ) {
        // change the recipient of this instance
        $wc_emails['WC_Email_Failed_Order']->recipient = $customer_email;
        // Sending the email from this instance
        $wc_emails['WC_Email_Failed_Order']->trigger( $order_id );
    } 
}


/* 4 columnas de categorias página de la tienda */
add_filter( 'storefront_product_categories_args', 'my_custom_storefront_category_args' );
function my_custom_storefront_category_args( $args ){
    $args = array(
                'limit'            => 4,
                'columns'          => 4,
                'child_categories' => 0,
                'orderby'          => 'menu_order',
                'title'            => __( 'Shop by Category', 'storefront' ),
            );
    return $args;
}


/*Borrar registros cada semana*/
add_filter( 'action_scheduler_retention_period', function(){
    return WEEK_IN_SECONDS;
} );

//Elimina una línea en las facturas
add_filter( 'yith_ywpi_show_tax_total_condition', '__return_false' );


/* Activar buscar por sku en la web */
function search_by_sku( $search, $query_vars ) {
global $wpdb;
if(isset($query_vars->query['s']) && !empty($query_vars->query['s'])){
$args = array(
'posts_per_page' => -1,
'post_type' => 'product',
'meta_query' => array(
array(
'key' => '_sku',
'value' => $query_vars->query['s'],
'compare' => 'LIKE'
)
)
);
$posts = get_posts($args);
if(empty($posts)) return $search;
$get_post_ids = array();
foreach($posts as $post){
$get_post_ids[] = $post->ID;
}
if(sizeof( $get_post_ids ) > 0 ) {
$search = str_replace( 'AND (((', "AND ((({$wpdb->posts}.ID IN (" . implode( ',', $get_post_ids ) . ")) OR (", $search);
}
}
return $search;
}
add_filter( 'posts_search', 'search_by_sku', 999, 2 );


/* Desactivar comprobador de fortaleza de contraseña WC */
function ayudawp_quitar_comprobar_clave() {
if ( wp_script_is( 'wc-password-strength-meter', 'enqueued' ) ) {
wp_dequeue_script( 'wc-password-strength-meter' );
}
} 
add_action( 'wp_print_scripts', 'ayudawp_quitar_comprobar_clave', 100 );


/* Eliminar campo de cupón en checkout
add_filter( 'woocommerce_coupons_enabled', 'dl_quitar_aviso_cupon_checkout' );
function dl_quitar_aviso_cupon_checkout( $enabled ) {
 if (is_checkout() ) {
 $enabled = false;
 }
 return $enabled;
}
*/

/* Agregar cabeceras de seguridad*/
function add_security_headers() {
    header( 'X-Content-Type-Options: nosniff' );
    header( 'X-Frame-Options: SAMEORIGIN' );
    header( 'X-XSS-Protection: 1;mode=block' );
    header( 'Strict-Transport-Security: max-age=10886400' );
    //header( 'Content-Security-Policy: default-src self' );
}
add_action( 'send_headers', 'add_security_headers' );

/* Nuevo estado en pedidos */
add_action( 'init', 'wphelp_new_order_status_sent' );
function wphelp_new_order_status_sent() {
register_post_status( 'wc-sent', array(
'label' => _x( 'En revisión', 'Order status', 'woocommerce' ),
'public' => true,
'exclude_from_search' => false,
'show_in_admin_all_list' => true,
'show_in_admin_status_list' => true,
'label_count' => _n_noop( 'En preparación <span class="count">(%s)</span> ', 'En preparación <span class="count">(%s)</span>', 'woocommerce' )
) );
}
// Agrega esto a los estados.
add_filter( 'wc_order_statuses', 'wphelp_order_sent' );
function wphelp_order_sent( $order_statuses ) {
$order_statuses['wc-sent'] = _x( 'En preparación', 'Order status', 'woocommerce' );
return $order_statuses;
}
// Añadir el estado del pedido a las acciones masivas en el orden que queramos
function rename_or_reorder_bulk_actions( $actions ) {
$actions = array(
'trash' => $actions['trash'], //Send to thrash
'mark_processing' => $actions['mark_processing'], //Procesando
'mark_on-hold' => $actions['mark_on-hold'], //En espera
'mark_cancelled' => $actions['mark_cancelled'], //Cancelado
'mark_completed' => $actions['mark_completed'], //Completado
'mark_sent' => __( 'Change to sent', 'En preparación' ), // NUEVO ESTADO PERSONALIZADO
);
return $actions;
}
add_filter( 'bulk_actions-edit-shop_order', 'rename_or_reorder_bulk_actions', 20 );


/* Mueve campo de notas en checkout 
// 1. Hide default notes
 
add_filter( 'woocommerce_enable_order_notes_field', '__return_false' );
 
// 2. Create new billing field
 
add_filter( 'woocommerce_checkout_fields' , 'bbloomer_custom_order_notes' );
 
function bbloomer_custom_order_notes( $fields ) {
   $fields['billing']['new_order_notes'] = array(
      'type' => 'textarea',
      'label' => 'Notas adicionales',
      'placeholder' => 'Por ejemplo, instrucciones para la entrega...',
      'class' => array('form-row-wide'),
      'clear' => true,
      'priority' => 999,
   );
   return $fields;
}
 
// 3. Save to existing order notes
 
add_action( 'woocommerce_checkout_update_order_meta', 'bbloomer_custom_field_value_to_order_notes', 10, 2 );
 
function bbloomer_custom_field_value_to_order_notes( $order_id, $data ) {
   if ( ! is_object( $order_id ) ) {
      $order = wc_get_order( $order_id );
   }
   if( $data['new_order_notes'] != '' ){
      $order->set_customer_note( $data['new_order_notes'] );
      wc_create_order_note( $order_id, $data['new_order_notes'], true, true );
      $order->save();
   }
}
*/


//Ocultar métodos de envío si existe método de envío gratis
add_filter( 'woocommerce_package_rates', 'oaf_unset_shipping_when_free_is_available_all_zones', 10, 2 );
   
function oaf_unset_shipping_when_free_is_available_all_zones( $rates, $package ) {
      
  $all_free_rates = array();
     
  foreach ( $rates as $rate_id => $rate ) {
    if ( 'free_shipping' === $rate->method_id ) {
       $all_free_rates[ $rate_id ] = $rate;
       break;
    }
  }
     
  if ( empty( $all_free_rates )) {
    return $rates;
  } else {
    return $all_free_rates;
  } 
 
}


/*Páginas restringidas a clientes no registrados*/

if( !function_exists('we_restrict_access_without_login') ):

add_action( 'template_redirect', 'we_restrict_access_without_login' );

function we_restrict_access_without_login(){

/* obtenemos la página actual o ID de la publicación */
$page_id = get_queried_object_id();

/* agregamos una listas de IDs de páginas o publicaciones para restricción */
$behind_login_pages = [ 9560 ];

if( ( !empty($behind_login_pages) && in_array($page_id, $behind_login_pages) ) && !is_user_logged_in() ):

wp_die(' No tienes permiso para acceder a esta página.');
return;
exit;

endif;
}

endif;

/* Mueve la descripción de las taxonomías de producto al final de la página */
remove_action( 'woocommerce_archive_description', 'woocommerce_taxonomy_archive_description', 10 );
add_action( 'woocommerce_after_shop_loop', 'woocommerce_taxonomy_archive_description' );


/* Mueve la descripción de las taxonomías de producto al final de la página */
add_action( 'wp_enqueue_scripts', 'dl_disable_woocommerce_cart_fragments_front_single', 11);
function dl_disable_woocommerce_cart_fragments_front_single() {
if (is_single() ) wp_dequeue_script('wc-cart-fragments');
}

/*Mensaje en vacaciones*/
add_action( 'woocommerce_review_order_after_submit', 'bbloomer_privacy_message_below_checkout_button' );
 
function bbloomer_privacy_message_below_checkout_button() {
   echo '<p align="justify"><strong>Por favor, revisa a continuación que tus datos de facturación y envío sean correctos. Una vez realizado el pedido no se pueden modificar</strong>.</p>';
}